<?php
/*
Plugin Name: WP-SWFObject
Plugin URI: http://blog.unijimpe.net/wp-swfobject/
Description: Allow insert Flash Movies into WordPress blog using SWFObject library. For use this plugin: [SWF]pathtofile, width, height[/SWF].
Version: 1.5
Author: Jim Penaloza Calixto 
Author URI: http://blog.unijimpe.net
*/

define("wp_swf_version", "swf_version", true);
define("wp_swf_bgcolor", "swf_bgcolor", true);
define("wp_swf_wmode", "swf_wmode", true);
define("wp_swf_menu", "swf_menu", true);
define("wp_swf_quality", "swf_quality", true);
define("wp_swf_message", "swf_message", true);

define("wp_swf_version_default", "8", true);
define("wp_swf_bgcolor_default", "#FFFFFF", true);
define("wp_swf_wmode_default", "window", true);
define("wp_swf_menu_default", "false", true);
define("wp_swf_quality_default", "high", true);
define("wp_swf_message_default", "This movie requires Flash Player 8", true);

add_option(wp_swf_version, wp_swf_version_default, 'Version of Flash Player.');
add_option(wp_swf_bgcolor, wp_swf_bgcolor_default, 'Background Color for Flash Movie.');
add_option(wp_swf_wmode, wp_swf_wmode_default, 'WMode for Flash Movie.');
add_option(wp_swf_menu, wp_swf_menu_default, 'Option for Activate menu for Flash Movie.');
add_option(wp_swf_quality, wp_swf_quality_default, 'Default quality for Flash Movie.');
add_option(wp_swf_message, wp_swf_message_default, 'Message for missing player.');

$idrnd = substr(md5(uniqid(rand(), true)),0,4);		// create unique id for divs
$flashcont = 0;        								// counter for files

function wpswfConfig() {
	// get config options into array var
    static $config;
    if ( empty($config) ) {
        $config['wp_swf_message'] = get_option(wp_swf_message);
        $config['wp_swf_wmode'] = get_option(wp_swf_wmode);
        $config['wp_swf_menu'] = get_option(wp_swf_menu);
        $config['wp_swf_quality'] = get_option(wp_swf_quality);
        $config['wp_swf_version'] = get_option(wp_swf_version);
        $config['wp_swf_bgcolor'] = get_option(wp_swf_bgcolor);
    }
    return $config;
}
function wpswfParse($text) {
    return preg_replace_callback('|\[swf\](.+?),\s*(\d+)\s*,\s*(\d+)\s*(,(.+?))?\[/swf\]|i', 'wpswfObject', $text);
}
function wpswfObject($match) {
    global $idrnd, $flashcont;
	$swf_config = wpswfConfig();
	$flashcont++;
	$writeswf = "\n";
    if (is_feed() || $doing_rss) {
		// for feed insert <object>
		$writeswf.= "<object type=\"application/x-shockwave-flash\" ";
		$writeswf.= "width=\"".$match[2]."\" height=\"".$match[3]."\">\n";
		$writeswf.= "<param name=\"movie\" value=\"".$match[1]."\" />\n";
		if ($match[4] != "") {
			$writeswf.= "<param name=\"flashvars\" value=\"".trim(substr($match[4],1))."\" />\n";
		}
		$writeswf.= "<embed src=\"".$match[1]."\" type=\"application/x-shockwave-flash\" ";
		$writeswf.= "width=\"".$match[2]."\" height=\"".$match[3]."\" ";
		if ($match[4] != "") {
			$writeswf.= "flashvars=\"".trim(substr($match[4],1))."\" ";
		}
		$writeswf.= ">\n";
		$writeswf.= "</object>\n";
	} else {
		// for web insert SWFObject
		$writeswf.= "<div id=\"swf".$idrnd."_".$flashcont."\" style=\"text-align:center;\">\n".$swf_config['wp_swf_message']."\n</div>\n";
		$writeswf.= "<script type=\"text/javascript\">\n";
		$writeswf.= "// <![CDATA[ \n";
		$writeswf.= "var so = new SWFObject(\"".$match[1]."\", \"id".$flashcont."\", ".$match[2].", ".$match[3].", \"".$swf_config['wp_swf_version']."\", \"".$swf_config['wp_swf_bgcolor']."\");\n";
		$writeswf.= "so.addParam(\"wmode\", \"".$swf_config['wp_swf_wmode']."\");\n";
		$writeswf.= "so.addParam(\"menu\", \"".$swf_config['wp_swf_menu']."\");\n";
		$writeswf.= "so.addParam(\"quality\", \"".$swf_config['wp_swf_quality']."\");\n";
		if ($match[4] != "") {
			parse_str(trim(substr($match[4],1)), $params);
			foreach ($params as $param => $value) {
				$writeswf.= "so.addVariable(\"".$param."\", \"".$value."\");\n";
			}
		}
		$writeswf.= "so.write(\"swf".$idrnd."_".$flashcont."\");\n";
		$writeswf.= "// ]]>\n";
		$writeswf.= "</script>\n";	
	}
	return $writeswf;
}
function wp_swfobject_echo($swffile, $swfwidth, $swfheigth, $swfvars = "") {
    echo wpswfObject( array( null, $swffile, $swfwidth, $swfheigth, $swfvars) );
}

function wpswfOptionsPage() {
	if (isset($_POST['wp_swf_update'])) {
		check_admin_referer();
		// Update version
		$swf_version = $_POST[wp_swf_version];
		if ($swf_version == '')
			$swf_version = wp_swf_version_default;
		update_option(wp_swf_version, $swf_version);
		// Update bgcolor
		$swf_bgcolor = $_POST[wp_swf_bgcolor];
		if ($swf_bgcolor == '')
			$swf_bgcolor = wp_swf_bgcolor_default;
		update_option(wp_swf_bgcolor, $swf_bgcolor);
		// Update wmode
		$swf_wmode = $_POST[wp_swf_wmode];
		update_option(wp_swf_wmode, $swf_wmode);
		// Update menu
		$swf_menu = $_POST[wp_swf_menu];
		update_option(wp_swf_menu, $swf_menu);
		// Update quality
		$swf_quality = $_POST[wp_swf_quality];
		update_option(wp_swf_quality, $swf_quality);
		// Update bgcolor
		$swf_message = $_POST[wp_swf_message];
		update_option(wp_swf_message, $swf_message);
		
		// echo message updated
		echo "<div class='updated'><p><strong>WP-SWFObject options updated</strong></p></div>";
	}
?>
		<form method="post" action="options-general.php?page=wp-swfobject.php">
		<div class="wrap">
			<h2>Options for WP-SWFObject <span style='font-size:12px;font-weight:bold;'><span style='color:red;'>v1.5</span></span></h2>
			<fieldset class='options'>
				<table class="editform" cellspacing="2" cellpadding="5" width="100%">
					<tr>
						<th width="30%" valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_version; ?>">Flash Player Version:</label>
						</th>
						<td>
							<?php
							echo "<input type='text' size='16' maxlength='1' ";
							echo "name='".wp_swf_version."' ";
							echo "id='".wp_swf_version."' ";
							echo "value='".get_option(wp_swf_version)."' />\n";
							?>
							Enter number of flash version required for flash player.
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_bgcolor; ?>">Background Color:</label>
						</th>
						<td>
							<?php
							echo "<input type='text' size='16' maxlength='7' ";
							echo "name='".wp_swf_bgcolor."' ";
							echo "id='".wp_swf_bgcolor."' ";
							echo "value='".get_option(wp_swf_bgcolor)."' />\n";
							?>
							Enter HEX number for background color for flash movie.
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_wmode; ?>">Window Mode:</label>
						</th>
						<td>
							<?php
							echo "<select name='".wp_swf_wmode."' id='".wp_swf_wmode."'>\n";

							echo "<option value='window'";
							if(get_option(wp_swf_wmode) == "window")
								echo " selected='selected'";
							echo ">Window</option>\n";
							
							echo "<option value='opaque'";
							if(get_option(wp_swf_wmode) == "opaque")
								echo " selected='selected'";
							echo ">Opaque</option>\n";
							
							echo "<option value='transparent'";
							if(get_option(wp_swf_wmode) == "transparent")
								echo " selected='selected'";
							echo ">Transparent</option>\n";
							
							echo "</select>\n";
							?>
							Select wmode for movie, by defaul is <strong>window</strong>.
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_menu; ?>">Show Menu:</label>
						</th>
						<td>
							<?php
							echo "<select name='".wp_swf_menu."' id='".wp_swf_menu."'>\n";

							echo "<option value='true'";
							if(get_option(wp_swf_menu) == "true")
								echo " selected='selected'";
							echo ">True</option>\n";
							
							echo "<option value='false'";
							if(get_option(wp_swf_menu) == "false")
								echo " selected='selected'";
							echo ">False</option>\n";
							
							echo "</select>\n";
							?>
							Select option for show/hide menu.
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_bgcolor; ?>">Quality Movie:</label>
						</th>
						<td>
							<?php
							echo "<select name='".wp_swf_quality."' id='".wp_swf_quality."'>\n";

							echo "<option value='low'";
							if(get_option(wp_swf_quality) == "low")
								echo " selected='selected'";
							echo ">Low</option>\n";
							
							echo "<option value='autolow'";
							if(get_option(wp_swf_quality) == "autolow")
								echo " selected='selected'";
							echo ">Autolow</option>\n";
							
							echo "<option value='autohigh'";
							if(get_option(wp_swf_quality) == "autohigh")
								echo " selected='selected'";
							echo ">autohigh</option>\n";
							
							echo "<option value='medium'";
							if(get_option(wp_swf_quality) == "medium")
								echo " selected='selected'";
							echo ">Medium</option>\n";
							
							echo "<option value='high'";
							if(get_option(wp_swf_quality) == "high")
								echo " selected='selected'";
							echo ">high</option>\n";
							
							echo "<option value='best'";
							if(get_option(wp_swf_quality) == "best")
								echo " selected='selected'";
							echo ">Best</option>\n";
							
							echo "</select>\n";
							?>
							Select quality for flash movie, by default is <strong>hight</strong>.
						</td>
					</tr>
					<tr>
						<th width="30%" valign="top" style="padding-top: 10px;">
							<label for="<?php echo wp_swf_version; ?>">Message Require Flash:</label>
						</th>
						<td>
							<?php
							echo "<input type='text' size='60' ";
							echo "name='".wp_swf_message."' ";
							echo "id='".wp_swf_message."' ";
							echo "value='".get_option(wp_swf_message)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter message for warning missing player.</p>
						</td>
					</tr>
					<tr>
						<td colspan="2">
						<p class="submit"><input type='submit' name='wp_swf_update' value='Update Options' /></p>
						</td>
					</tr>
					<tr>
						<th width="30%" valign="top" style="padding-top: 10px; text-align:left;" colspan="2">
							Informations and support
						</th>
					</tr>
					<tr>
						<td colspan="2">
						Check <a href="http://blog.unijimpe.net/wp-swfobject/">http://blog.unijimpe.net/wp-swfobject/</a> for updates and comment there if you have any problems / questions / suggestions.
						</td>
					</tr>
				</table>
			</fieldset>
		</div>
		</form>
<?php
}
function wpswfAddMenu() {
	add_options_page('WP-SWFObject Options', 'WP-SWFObject', 8, basename(__FILE__), 'wpswfOptionsPage');
}
function wpswfAddheader() {
	echo "<!-- WP-SWFObject 1.5 by unijimpe -->\n";
	echo "<script src=\"".get_settings('siteurl')."/wp-content/plugins/swfobject.js\" type=\"text/javascript\"></script>\n";
}

add_filter('the_content', 'wpswfParse');
add_action('wp_head', 'wpswfAddheader');
add_action('admin_menu', 'wpswfAddMenu');
?>